# The LearningOnline Network
# Logout Handler
#
# $Id: lonlogout.pm,v 1.10 2003/06/06 02:24:49 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Cookie Based Access Handler
# 5/21/99,5/22,5/29,5/31,6/15,16/11,22/11,
# 01/06,01/13 Gerd Kortemeyer)
# 05/31,11/29,12/29 Gerd Kortemeyer

package Apache::lonlogout;

use strict;
use Apache::Constants qw(:common);
use Apache::File;
use Apache::lonnet;
use Apache::lonmenu;
use CGI::Cookie();

sub handler {
    my $r = shift;

    my $requrl=$r->uri;
    my %cookies=CGI::Cookie->parse($r->header_in('Cookie'));
    my $lonid=$cookies{'lonID'};
    my $cookie;
    if ($lonid) {
	my $handle=$lonid->value;
        $handle=~s/\W//g;
        my $lonidsdir=$r->dir_config('lonIDsDir');
        if ((-e "$lonidsdir/$handle.id") && ($handle ne '')) {
           my @profile;
           my %sessionhash;
	    {
             my $idf=Apache::File->new("$lonidsdir/$handle.id");
             @profile=<$idf>;
	    }
            my $envi;
            for ($envi=0;$envi<=$#profile;$envi++) {
		chomp($profile[$envi]);
		my ($envname,$envvalue)=split(/=/,$profile[$envi]);
                $sessionhash{$envname}=$envvalue;
            }
            unlink("$lonidsdir/$handle.id");
	    my %temp=('logout' => time);
	    &Apache::lonnet::put('email_status',\%temp);
	    &Apache::lonnet::log($sessionhash{'user.domain'},
                                 $sessionhash{'user.name'},
                                 $sessionhash{'user.home'},
                                 "Logout $ENV{'REMOTE_ADDR'}");
            $r->content_type('text/html');
            $r->send_http_header;
            return OK if $r->header_only;
# -------------------------------------------------------- Menu script and info

    my $windowinfo=&Apache::lonmenu::close();
# ---------------------------------------------------------------- Get handover
    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},['handover']);
    my $switch='';
    my $bodytag='';
    my $relogmessage='';
    if ($ENV{'form.handover'}) {
       $switch='<meta HTTP-EQUIV="Refresh" CONTENT="0.5; url='.
	   $ENV{'form.handover'}.'">';
       $bodytag=&Apache::loncommon::bodytag('Switching Server ...');
   } else {
       $bodytag=&Apache::loncommon::bodytag('Logged Out');
       $relogmessage=(<<ENDRELOG);
<h1>Goodbye!</h1>
Please either <a href="javascript:self.close();">close this window</a> or
<a href="/adm/login">log in again</a>.
ENDRELOG
   }
# --------------------------------------------------------------- Screen Output
            $r->print(<<ENDDOCUMENT);
<html>
<head><title>The LearningOnline Network with CAPA Logout</title>
$switch
</head>
$bodytag
$windowinfo
$relogmessage
</body>
</html>
ENDDOCUMENT
            &Apache::lonnet::flushcourselogs();
            return OK; 
        } else { 
            $r->log_reason("Cookie $handle not valid", $r->filename); 
        }
    }
    return FORBIDDEN;
}

1;
__END__








