# The LearningOnline Network
# Access Handler for User File Transfers
#
# $Id: lontokacc.pm,v 1.9 2003/08/01 17:25:40 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::lontokacc;

use strict;
use Apache::Constants qw(:common :remotehost);
use Apache::lonnet();
use Apache::File();


sub handler {
    my $r = shift;
    my $reqhost = $r->get_remote_host(REMOTE_DOUBLE_REV);
    if (!$reqhost && $r->get_remote_host(REMOTE_NOLOOKUP) eq $r->get_server_name()) { 
        $reqhost = $r->get_server_name(); 
    }
    unless ($reqhost) {
        $r->log_reason("Spoof request from ". $reqhost);
        return FORBIDDEN;
    }
    if ($reqhost eq 'localhost.localdomain') {
       return OK;
    }
    my $readline;
    my $lontabdir=$r->dir_config('lonTabDir');
    {
       my $fh;
       unless ($fh=Apache::File->new("$lontabdir/hosts.tab")) {
          $r->log_reason("Could not find host tab file");
          return FORBIDDEN;
       }
       while ($readline=<$fh>) {
          my ($id,$domain,$role,$name,$ip)=split(/:/,$readline);
          if ($name =~ /$reqhost/i) {
             return OK; 
          }
       }

    }
    $r->log_reason("Invalid request for user file transfer from $reqhost", 
                   $r->filename); 
    return FORBIDDEN;
}

sub removefile {
    my $r=shift;
    if ($r->status==200) {
        unlink($r->filename);
	&Apache::lonnet::logthis('Unlinking '.$r->filename);
    } else {
        &Apache::lonnet::logthis('Failed to transfer '.$r->filename);
    }
}
1;
__END__







