# The LearningOnline Network with CAPA
# chemical equation style response
#
# $Id: chemresponse.pm,v 1.11 2003/07/01 21:10:43 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
#
package Apache::chemresponse;
use strict;
use Apache::lonxml;
use Apache::lonnet;

BEGIN {
    &Apache::lonxml::register('Apache::chemresponse',('organicresponse','organicstructure','reactionresponse'));
}

sub seperate_jme_window {
    my ($smile_input,$jme_input,$molecule,$options)=@_;
    my $smilesection;
    if (defined($smile_input)) {
	$smilesection=<<SMILESECTION;
	opener.document.lonhomework.$smile_input.value = smiles;
SMILESECTION
    }
    my $jmesection;
    if (defined($jme_input)) {
	$jmesection=<<JMESECTION;
	jmeFile = document.applets.JME.jmeFile();
	opener.document.lonhomework.$jme_input.value = jmeFile;
JMESECTION
    }

    my $body=<<CHEMPAGE;
<html>
<head>
<title>Molecule Editor</title>
<script language="JavaScript">
function submitSmiles() {
    smiles = document.applets.JME.smiles();
    if (smiles == "") {
	alert("Nothing to submit");
    } else {
        $smilesection
        $jmesection
	window.close();
    }
}
function openHelpWindow() {
    window.open("/adm/jme/jme_help.html","","scrollbars=yes,resizable=yes,width=500,height=600");
}
</script>
</head>
<body bgcolor="#ffffff">
<center>
<applet code="JME.class" name="JME" archive="/adm/jme/JME.jar" width="97%" height="78%">
You have to enable Java and JavaScript on your machine.
<param name="jme" value="$molecule" />
<param name="options" value="$options" />
</applet><br />
<font face="arial,helvetica,sans-serif" size=-1><a href="http://www.molinspiration.com/jme/index.html">JME Editor</a> courtesy of Peter Ertl, Novartis</font>
<form>
<input type="button" name="submit" value="Insert Answer" onClick = "submitSmiles();" />
<br />
<input type="button" value="  Close  " onClick = "window.close()" />
&nbsp;&nbsp;
<input type="button" value="  Help  " onClick = "openHelpWindow()" />
</form>
</center>
</body>
</html>
CHEMPAGE
    $body=&HTML::Entities::encode($body);
    $body=~s/\n/ /g;
    my $result=<<CHEMINPUT;
<input type="button" value="Draw Molecule" onClick="javascript:editor=window.open('','','width=500,height=500,scrollbars=no,resizable=yes');editor.document.open('text/html','replace');editor.document.writeln('$body')" />
CHEMINPUT
    return $result;
}

sub start_organicresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    my $partid = $Apache::inputtags::part;
    my $id = &Apache::response::start_response($parstack,$safeeval);
    if ($target eq 'meta') {
    } elsif ($target eq 'web') {
	my $molecule;
	if (defined($Apache::lonhomework::history{"resource.$partid.$id.molecule"})) {
	    $molecule=$Apache::lonhomework::history{"resource.$partid.$id.molecule"};
	} else {
	    $molecule=&Apache::lonxml::get_param('molecule',$parstack,
						 $safeeval);
	}
	my $multipart=&Apache::lonxml::get_param('multipart',$parstack,
						 $safeeval);
	if ($multipart eq 'yes') {
	    $multipart = 'multipart';
	} else {
	    $multipart ='';
        }
	$result=&seperate_jme_window("HWVAL_$id","MOLECULE_$id",$molecule,$multipart);
	$result.= '<input type="hidden" name="MOLECULE_'.$id.'" value="" />';
    } elsif ($target eq 'edit') {
	$result .=&Apache::edit::tag_start($target,$token);
	$result .='<nobr>'.
	    &Apache::edit::text_arg('Starting Molecule:','molecule',
				    $token,40);
	my $molecule=&Apache::lonxml::get_param('molecule',$parstack,
						$safeeval);
	$result .=&seperate_jme_window(undef,
		      &Apache::edit::html_element_name('molecule'),
		      $molecule,'multipart');
	$result .='</nobr><br /><nobr>';
	$result .=&Apache::edit::text_arg('Correct Answer:','answer',
					  $token,40);
	$result .=&Apache::edit::hidden_arg('jmeanswer',$token);
	my $jmeanswer=&Apache::lonxml::get_param('jmeanswer',$parstack,
						 $safeeval);
	$result .=&seperate_jme_window(
                      &Apache::edit::html_element_name('answer'),
                      &Apache::edit::html_element_name('jmeanswer'),
		      $jmeanswer,'multipart');
	$result .='</nobr>'.
	    &Apache::edit::select_arg('Multipart:','multipart',
				      ['no','yes'],$token);
	$result .=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
    } elsif ($target eq 'modified') {
	my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						     $safeeval,'molecule',
						     'answer','jmeanswer',
						     'multipart');
	if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
    }
    return $result;
}

sub end_organicresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'grade' && defined($ENV{'form.submitted'})) {
	&Apache::response::setup_params($$tagstack[-1]);
	my $response = &Apache::response::getresponse();
	if ( $response =~ /[^\s]/) {
	    my $partid = $Apache::inputtags::part;
	    my $id = $Apache::inputtags::response['-1'];
	    my $answer=&Apache::lonxml::get_param('answer',$parstack,$safeeval);
	    my %previous = &Apache::response::check_for_previous($response,$partid,$id);
	    $Apache::lonhomework::results{"resource.$partid.$id.submission"}=$response;
	    &Apache::lonxml::debug("submitted a $response for $answer<br \>\n");
	    my $ad;
	    if ($response eq $answer) {
		$ad='EXACT_ANS';
	    } else {
		$ad='INCORRECT';
	    }
	    &Apache::response::handle_previous(\%previous,$ad);
	    $Apache::lonhomework::results{"resource.$partid.$id.awarddetail"}=$ad;
	    $Apache::lonhomework::results{"resource.$partid.$id.molecule"}=$ENV{"form.MOLECULE_$id"};
	}
    } elsif ($target eq "edit") {
	$result.= &Apache::edit::tag_end($target,$token,'');
    }
    &Apache::response::end_response;
    return $result;
}

sub start_organicstructure {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'web') {
	my $width=&Apache::lonxml::get_param('width',$parstack,$safeeval);
	my $height=&Apache::lonxml::get_param('height',$parstack,$safeeval);
	my $molecule=&Apache::lonxml::get_param('molecule',$parstack,$safeeval);
	$result=<<CHEMOUTPUT;
<applet code="JME.class" archive="/adm/jme/JME.jar" width="$width" height="$height">
<param name="options" value="depict border" />
<param name="jme" value="$molecule" />
</applet>
CHEMOUTPUT
    } elsif ($target eq 'edit') {
	$result .=&Apache::edit::tag_start($target,$token);
	$result .=&Apache::edit::text_arg('Width:','width',$token,5);
	$result .=&Apache::edit::text_arg('Height:','height',$token,5);
	$result .=&Apache::edit::text_arg('Molecule:','molecule',$token,40);
	my $molecule=&Apache::lonxml::get_param('molecule',$parstack,
						$safeeval);
	$result .=&seperate_jme_window(undef,
		      &Apache::edit::html_element_name('molecule'),
		      $molecule,'multipart');
	$result .=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
    } elsif ($target eq 'modified') {
	my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						     $safeeval,'molecule',
						     'width','height');
	if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
    }
    return $result;
}

sub end_organicstructure {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq "edit") {
	$result.= &Apache::edit::tag_end($target,$token,'');
    }
    return $result;
}

sub edit_reaction_button {
    my ($id,$field,$reaction)=@_;
    my $id_es=&Apache::lonnet::escape($id);
    my $field_es=&Apache::lonnet::escape($field);
    my $reaction_es=&Apache::lonnet::escape($reaction);
    my $result=<<EDITREACTION;
<script type="text/javascript">
    function create_reaction_window_${id}_${field} () {
	editor=window.open('','','width=500,height=270,scrollbars=no,resizable=yes');
	editor.document.open('text/html','replace');
	editor.document.writeln('<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN"><html> <head><title>LON-CAPA Reaction Editor</title></head><frameset rows="30%,*" border="0">  <frame src="/res/adm/pages/reactionresponse/reaction_viewer.html" name="viewer" scrolling="no" />  <frame src="/res/adm/pages/reactionresponse/reaction_editor.html?reaction=$reaction_es&id=$id_es&field=$field_es" name="editor" scrolling="no" /> </frameset> </html>');
    }
</script>
<input type='button' value='Edit Reaction' onClick="javascript:create_reaction_window_${id}_${field}();void(0);" />
EDITREACTION
    return $result;
}

sub start_reactionresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    my $id = &Apache::response::start_response($parstack,$safeeval);
    if ($target eq 'meta') {
    } elsif ($target eq 'web') {
	my $partid = $Apache::inputtags::part;
	my $id = $Apache::inputtags::response['-1'];
	my $reaction=$Apache::lonhomework::history{"resource.$partid.$id.submission"};
	$result.=&edit_reaction_button($id,"HWVAL_$id",$reaction);
    } elsif ($target eq "edit") {
	$result .=&Apache::edit::tag_start($target,$token);
	my $answer=&Apache::lonxml::get_param('answer',$parstack,
						$safeeval);
	$result .='<nobr>'.
	    &Apache::edit::text_arg('Answer:','answer',$token,40);
	$result .=&edit_reaction_button($id,&Apache::edit::html_element_name('answer'),$answer).'</nobr>';
	
	$result .=&Apache::edit::end_row().&Apache::edit::start_spanning_row();
    }  elsif ($target eq 'modified') {
	my $constructtag=&Apache::edit::get_new_args($token,$parstack,
						     $safeeval,'answer');
	if ($constructtag) { $result = &Apache::edit::rebuild_tag($token); }
    }
    return $result;
}

sub end_reactionresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    if ($target eq 'grade' && defined($ENV{'form.submitted'})) {
	&Apache::response::setup_params($$tagstack[-1]);
	my $response = &Apache::response::getresponse();
	if ( $response =~ /[^\s]/) {
	    my $partid = $Apache::inputtags::part;
	    my $id = $Apache::inputtags::response['-1'];
	    my $answer=&Apache::lonxml::get_param('answer',$parstack,$safeeval);
	    my %previous = &Apache::response::check_for_previous($response,$partid,$id);
	    $Apache::lonhomework::results{"resource.$partid.$id.submission"}=$response;
	    &Apache::lonxml::debug("submitted a $response for $answer<br \>\n");
	    my $ad;
	    if ($response eq $answer) {
		$ad='EXACT_ANS';
	    } else {
		$ad='INCORRECT';
	    }
	    &Apache::response::handle_previous(\%previous,$ad);
	    $Apache::lonhomework::results{"resource.$partid.$id.awarddetail"}=$ad;
	}
    }  elsif ($target eq "edit") {
	$result.= &Apache::edit::tag_end($target,$token,'');
    }
    &Apache::response::end_response;
    return $result;
}

1;
__END__
