# The LearningOnline Network with CAPA
# essay (ungraded) style responses
#
# $Id: essayresponse.pm,v 1.32 2003/04/29 20:32:21 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# 4/3 Guy
# July, 2002, H. K. Ng
#
package Apache::essayresponse;
use strict;
use Apache::lonxml;
use Apache::lonnet;

BEGIN {
    &Apache::lonxml::register('Apache::essayresponse',('essayresponse'));
}

sub start_essayresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $result;
    my $id = &Apache::response::start_response($parstack,$safeeval);
    if ($target eq 'meta') {
	$result=&Apache::response::meta_package_write('essayresponse');
    } elsif ($target eq 'web') {
	my $part= $Apache::inputtags::part;

	my $ncol= &Apache::lonnet::EXT("resource.$part".'_'."$id.maxcollaborators");
	my $coll= &HTML::Entities::encode($Apache::lonhomework::history{"resource.$part.$id.collaborators"});
	my $uploadedfiletypes= &Apache::lonnet::EXT("resource.$part".'_'."$id.uploadedfiletypes");
        $uploadedfiletypes=~s/[^\w\,]//g;
	my $uploadedfile= &HTML::Entities::encode($Apache::lonhomework::history{"resource.$part.$id.uploadedfile"});
	$result='<br /><table border="1">';
	$result.='<tr><td>'.
	    '<input type="radio" name="HWDRAFT'.$part.'_'.$id.'" value="yes" checked>'.
	    ' Submit entries below as answer to receive credit <br />'.
	    '<input type="radio" name="HWDRAFT'.$part.'_'.$id.'" value="no">'.
	    ' Save entries below as a draft answer (not submitting them for credit yet) '.
	    '</td></tr>';
	if ($ncol > 0) {
	    $result .='<tr><td>'.
		'Collaborators: <input type="text" size="70" max="80" name="HWCOL'.
		$part.'_'.$id.'" value="'.$coll.'" /><br />'.
		'(Enter maximum '.$ncol.' collaborators using username or username@domain, e.g. '.
		'smithje or smithje@'.$ENV{'user.domain'}.'.)<br />';
	    $result .= &check_collaborators($ncol,$coll) if ($coll =~ /\w+/);
	    $result .='</td></tr>';
	}
        if ($uploadedfiletypes) {
           $result.=
'<tr><td>Submit a file: <input type="file" size="50" name="HWFILE'.
		$part.'_'.$id.'" onFocus="this.form.enctype='.
"'multipart/form-data'".';" /><br />Allowed filetypes: <b>'.$uploadedfiletypes.'</b><br />';
           if ($uploadedfile) {
	       $result.='Currently submitted: <tt><a href="'.
                &Apache::lonnet::tokenwrapper($Apache::lonhomework::history{"resource.$part.$id.uploadedurl"}).'"><img src="/adm/lonIcons/unknown.gif" border=0"> '.$uploadedfile.'</a></tt>';
           } else {
              $result.='(Hand in a file you have prepared on your computer)';
           }
           $result.='</td></tr>'; 
        }
        $result.='</table>';
    }
    return $result;
}

sub end_essayresponse {
    my ($target,$token,$tagstack,$parstack,$parser,$safeeval,$style)=@_;
    my $part          = $Apache::inputtags::part;
    my $id            = $Apache::inputtags::response[-1];
    my $increment     = 1;
    my $result;
    if ( $target eq 'grade' ) {
	my $collaborators = $ENV{'form.HWCOL'.$part.'_'.$id};	
	if ($collaborators =~ /[^\s]/) {
	    my $previous_list= &HTML::Entities::encode($Apache::lonhomework::history{"resource.$part.$id.collaborators"});
	    $Apache::lonhomework::results{"resource.$part.$id.collaborators"}=$collaborators
		if ($collaborators ne $previous_list);
	}
	if ( defined($ENV{'form.submitted'}) &&
	     $ENV{'form.submitted'} eq 'scantron' ) {
	    $increment=&Apache::response::scored_response($part,$id);
	} elsif ( defined($ENV{'form.submitted'}) ) {
	    my $response      = $ENV{'form.HWVAL_'.$id};
            my $filename= $ENV{'form.HWFILE'.$part.'_'.$id.'.filename'};
	    if (( $response =~ /[^\s]/) || ($filename =~ /[^\s]/)) {
 		my $award;
		if ($ENV{'form.HWDRAFT'.$part.'_'.$id} eq 'yes') {
		    $award='SUBMITTED';
		} else {
		    $award='DRAFT';
		}
                my $uploadedflag=0;
                if ($filename =~ /[^\s]/) {
 	           my $uploadedfiletypes= &Apache::lonnet::EXT("resource.$part".'_'."$id.uploadedfiletypes");
                   $uploadedfiletypes=~s/[^\w\,]//g;
                   $uploadedfiletypes=','.$uploadedfiletypes.',';
                   my ($extension)=($filename=~/\.(\w+)$/);
	           if ($uploadedfiletypes=~/\,$extension\,/i) {
	              $Apache::lonhomework::results{"resource.$part.$id.uploadedfile"}=$filename;
                      $Apache::lonhomework::results{"resource.$part.$id.uploadedurl"}=
                         &Apache::lonnet::userfileupload('HWFILE'.$part.'_'.$id);
                      $uploadedflag=1;
		   } else {
		      $award='INVALID_FILETYPE';
                   }
	        }
		$Apache::lonhomework::results{"resource.$part.$id.submission"}=$response;
		$Apache::lonhomework::results{"resource.$part.$id.awarddetail"}=$award;
		my %previous=&Apache::response::check_for_previous($response,$part,$id);
		unless ($uploadedflag) { &Apache::response::handle_previous(\%previous,$award); }
#
# Store with resource author for similarity testing
#
                if ($award eq 'SUBMITTED') {
		    my ($symb,$crsid,$domain,$name)=
			&Apache::lonxml::whichuser();
		    if ($crsid) {
			my $akey=$name.'.'.$domain.'.'.$crsid;
			my $essayurl=
			    &Apache::lonnet::declutter($ENV{'REQUEST_URI'});
			my ($adom,$aname,$apath)=
			    ($essayurl=~/^(\w+)\/(\w+)\/(.*)$/);
                        $apath=&Apache::lonnet::escape($apath);
			$apath=~s/\W/\_/gs;
			&Apache::lonnet::put('nohist_essay_'.$apath,
					 { $akey => $response },$adom,$aname);
		    }
               }
	    }
	}
    } elsif ($target eq 'edit') {
	$result.=&Apache::edit::end_table();
    } elsif ($target eq 'tex') {
	if ($Apache::lonhomework::type eq 'exam') {
	    my $repetition=&Apache::response::repetition();
	    $result.='\begin{enumerate}';
	    for (my $i=0;$i<$repetition;$i++) {
		$result.='\item[\textbf{'.($Apache::lonxml::counter+$i).
		    '}.]\textit{Leave blank on scoring form}\vskip 0 mm';
	    }
	    $result.= '\end{enumerate}';
	}
    }
    if ($target eq 'grade' || $target eq 'web' || $target eq 'answer' ||
	$target eq 'tex' || $target eq 'analyze') {
	&Apache::lonxml::increment_counter($increment);
    }
    &Apache::response::end_response;
    return $result;
}

sub check_collaborators {
    my ($ncol,$coll) = @_;
    my %classlist=&Apache::lonnet::dump('classlist',
					$ENV{'course.'.$ENV{'request.course.id'}.'.domain'},
					$ENV{'course.'.$ENV{'request.course.id'}.'.num'});
    my (@badcollaborators,$result);
    my (@collaborators) = split(/\,?\s+/,$coll);
    foreach (@collaborators) {
	my $collaborator = $_;
	if (/@/) {
	    $collaborator =~ s/@/:/;
	} else {
	    $collaborator = $_.':'.$ENV{'user.domain'};
	}
	push @badcollaborators, $_ if (!grep /^$collaborator/i,keys %classlist);
    }
    
    if (scalar(@badcollaborators)) {
	$result = '<table border="0"><tr bgcolor="#ffbbbb"><td> The following user'.
	    (scalar(@badcollaborators) > 1 ? 's are' : ' is').' invalid: '.
	    join(', ',@badcollaborators).'. Please correct.</td></tr></table>';
    }
    my $toomany = scalar(@collaborators) - $ncol;
    if ($toomany > 0) {
	$result .= '<table border="0"><tr bgcolor="#ffbbbb"><td>'.
	    'You have too many collaborators. Please remove '.$toomany.' collaborator'.
	    ($toomany > 1 ? 's' :'').'.</td></tr></table>';
    }
    return $result;
}

1;
__END__
