# The LearningOnline Network
# Chat
#
# $Id: lonchat.pm,v 1.7 2003/07/24 17:53:59 matthew Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::lonchat;

use strict;
use Apache::Constants qw(:common :http);
use Apache::loncommon;

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;
    if (! &Apache::lonnet::allowed('plc',$ENV{'request.course.id'}.
              ($ENV{'request.course.sec'}?'/'.$ENV{'request.course.sec'}:'')
                                   )) {
        return HTTP_NOT_ACCEPTABLE;
    }

    if ($ENV{'form.newchat'}) {
	&Apache::lonnet::chatsend(&Apache::lonfeedback::clear_out_html($ENV{'form.newchat'}),$ENV{'form.anonymous'});
    }
# --------------------------------------------------- Print login screen header
    my $latexHelp = Apache::loncommon::helpLatexCheatsheet();
    $r->print(<<ENDDOCUMENT);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
<body bgcolor="#FFFFFF" onLoad="this.document.chatentry.newchat.focus();">
<form method="post" name="chatentry">
$latexHelp
<input type="text" size="60" name="newchat">
<input value="Post Anonymous" name="anonymous" type="submit">
<input value="Post" name="newentry" type="submit">
</form>
</body>
</html>
ENDDOCUMENT
    return OK;
} 

1;
__END__
