# The LearningOnline Network
# Communicate
#
# $Id: loncommunicate.pm,v 1.15 2002/12/30 14:10:58 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Internal Server Error Handler
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer)
#
# 3/1,2/6,7/27,8/3,8/15,
# 11/5/01 Gerd Kortemeyer
#
package Apache::loncommunicate;

use strict;
use Apache::Constants qw(:common);
use Apache::lonmsg();
use Apache::loncommon;

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;
#
# Start document
#
    $r->print(<<END);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
END
   $r->print(&Apache::loncommon::bodytag("Communication and Messages"));
   $r->print(<<END);
<table cellspacing="10" cellpadding="2">
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email/">View All Messages</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?critical=display">View Critical Messages</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=individual">Send message to user(s)</a></b>
</td></tr>
END
    if (($ENV{'request.course.id'}) && 
        (&Apache::lonnet::allowed('srm',$ENV{'request.course.id'}))) {
        $r->print(<<END);
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=group">Broadcast message to course</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?compose=upload">Distribute messages from uploaded file to course</a></b>
</td></tr>
<tr><td bgcolor="#FFFFAA">
  <b><a href="/adm/email?recordftf=query">User notes, records of face-to-face discussions, and critical messages</a></b>
</td></tr>

END
    }
    $r->print('</table>');
    my @msgids = sort split(/\&/,&Apache::lonnet::reply
                            ('keys:'.$ENV{'user.domain'}.':'.
                             $ENV{'user.name'}.':nohist_email',
                             $ENV{'user.home'}));
    my @newmsgs;
    foreach (@msgids) {
        my ($sendtime,$shortsubj,$fromname,$fromdom,$status)=
	    &Apache::lonmsg::unpackmsgid($_);
       if (defined($sendtime) && $sendtime!~/error/) {
        $sendtime = localtime($sendtime);
        if ($status eq 'new') {
            push @newmsgs, { 
                msgid    => $_,
                sendtime => $sendtime,
                shortsub => &Apache::lonnet::unescape($shortsubj),
                from     => $fromname,
                fromdom  => $fromdom 
                }
        }
       }
    }
    if ($#newmsgs >= 0) {
        $r->print(<<TABLEHEAD);
<h3>New Messages</h3>
<table border=2><tr><th>&nbsp</th>
<th>Date</th><th>Username</th><th>Domain</th><th>Subject</th></tr>
TABLEHEAD
        foreach my $msg (@newmsgs) {
            $r->print(<<"ENDLINK");
<tr bgcolor="#FFBB77">
<td><a href="/adm/email?display=$msg->{'msgid'}">Open</a></td>
ENDLINK
            foreach ('sendtime','from','fromdom','shortsub') {
                $r->print("<td>$msg->{$_}</td>");
            }
            $r->print("</td></tr>");
        }
        $r->print('</table></body></html>');
    } else {
        $r->print("<h3>You have no unread messages</h3>");
    }
    return OK;
}

1;
__END__
