# The LearningOnline Network
# Documents
#
# $Id: londocs.pm,v 1.69.2.1.2.2 2003/08/07 19:12:42 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::londocs;

use strict;
use Apache::Constants qw(:common :http);
use Apache::lonnet;
use Apache::loncommon;
use Apache::lonratedt;
use Apache::lonratsrv;
use Apache::lonxml;
use HTML::Entities;
use GDBM_File;

my $iconpath;

my %hash;

my $hashtied;
my %alreadyseen=();

my $hadchanges;

# Available help topics

my %help=();

# Mapread read maps into lonratedt::global arrays 
# @order and @resources, determines status
# sets @order - pointer to resources in right order
# sets @resources - array with the resources with correct idx
#

sub mapread {
    my ($coursenum,$coursedom,$map)=@_;
    return
      &Apache::lonratedt::mapread('/uploaded/'.$coursedom.'/'.$coursenum.'/'.
                                $map);
}

sub storemap {
    my ($coursenum,$coursedom,$map)=@_;
    $hadchanges=1;
    return
      &Apache::lonratedt::storemap('/uploaded/'.$coursedom.'/'.$coursenum.'/'.
                                $map,1);
}

sub editor {
    my ($r,$coursenum,$coursedom,$folder,$allowed)=@_;
    if ($ENV{'form.foldername'}) {
	$r->print('<h3>Folder: '.$ENV{'form.foldername'}.'</h3>');
    }
    my $errtext='';
    my $fatal=0;
    ($errtext,$fatal)=
          &mapread($coursenum,$coursedom,$folder.'.sequence');
    if ($#Apache::lonratedt::order<1) {
       	$Apache::lonratedt::order[0]=1;
        $Apache::lonratedt::resources[1]='';
    }
    if ($fatal) {
	   $r->print('<p><font color="red">'.$errtext.'</font></p>');
    } else {
# ------------------------------------------------------------ Process commands
# ---------------- if they are for this folder and user allowed to make changes
	if (($allowed) && ($ENV{'form.folder'} eq $folder)) {
# upload a file, if present
           if (($ENV{'form.uploaddoc.filename'}) &&
               ($ENV{'form.cmd'}=~/^upload_(\w+)/)) {
	    if ($folder=~/^$1/) {
# this is for a course, not a user, so set coursedoc flag
# probably the only place in the system where this should be "1"
	      my $url=&Apache::lonnet::userfileupload('uploaddoc',1);
              my $ext='false';
              if ($url=~/^http\:\/\//) { $ext='true'; }
              $url=~s/\:/\&colon;/g;
	      my $comment=$ENV{'form.comment'};
              $comment=~s/\</\&lt\;/g;
              $comment=~s/\>/\&gt\;/g;
              $comment=~s/\:/\&colon;/g;
              if ($folder=~/^supplemental/) {
		  $comment=time.'___&&&___'.$ENV{'user.name'}.'___&&&___'.
		      $ENV{'user.domain'}.'___&&&___'.$comment;
              }
              my $newidx=$#Apache::lonratedt::resources+1;
              $Apache::lonratedt::resources[$newidx]=
                  $comment.':'.$url.':'.$ext.':normal:res';
              $Apache::lonratedt::order[$#Apache::lonratedt::order+1]=
                                                              $newidx;       
 	      &storemap($coursenum,$coursedom,$folder.'.sequence');
	     }
            }
	    if ($ENV{'form.cmd'}) {
                my ($cmd,$idx)=split(/\_/,$ENV{'form.cmd'});
                if ($cmd eq 'del') {
		    for (my $i=$idx;$i<$#Apache::lonratedt::order;$i++) {
                        $Apache::lonratedt::order[$i]=
                          $Apache::lonratedt::order[$i+1];
                    }
                    $#Apache::lonratedt::order--;
                } elsif ($cmd eq 'up') {
		  if (($idx) && (defined($Apache::lonratedt::order[$idx-1]))) {
                    my $i=$Apache::lonratedt::order[$idx-1];
                    $Apache::lonratedt::order[$idx-1]=
			$Apache::lonratedt::order[$idx];
                    $Apache::lonratedt::order[$idx]=$i;
		   }
                } elsif ($cmd eq 'down') {
		   if (defined($Apache::lonratedt::order[$idx+1])) {
                    my $i=$Apache::lonratedt::order[$idx+1];
                    $Apache::lonratedt::order[$idx+1]=
			$Apache::lonratedt::order[$idx];
                    $Apache::lonratedt::order[$idx]=$i;
		   }
                } elsif ($cmd eq 'rename') {
                    my ($rtitle,@rrest)=split(/\:/,
                       $Apache::lonratedt::resources[
				       $Apache::lonratedt::order[$idx]]);
                    my $comment=
                     &HTML::Entities::decode($ENV{'form.title'});
                    $comment=~s/\</\&lt\;/g;
                    $comment=~s/\>/\&gt\;/g;
                    $comment=~s/\:/\&colon;/g;
                    $Apache::lonratedt::resources[
				       $Apache::lonratedt::order[$idx]]=
                             $comment.':'.join(':',@rrest);
                    
                }
# Store the changed version
		&storemap($coursenum,$coursedom,$folder.'.sequence');
            }
# Group import/search
	    if ($ENV{'form.importdetail'}) {
               foreach (split(/\&/,$ENV{'form.importdetail'})) {
                  if (defined($_)) {
	             my ($name,$url)=split(/\=/,$_);
                     $name=&Apache::lonnet::unescape($name);
                     $url=&Apache::lonnet::unescape($url);
                     if ($url) {
	                my $idx=$#Apache::lonratedt::resources+1;
                        $Apache::lonratedt::order
                           [$#Apache::lonratedt::order+1]=$idx;
                        my $ext='false';
                        if ($url=~/^http\:\/\//) { $ext='true'; }
                        $url=~s/\:/\&colon;/g;
                        $name=~s/\:/\&colon;/g;
                        $Apache::lonratedt::resources[$idx]=
                           $name.':'.$url.':'.$ext.':normal:res';
	             }
                 }
	      }
# Store the changed version
		&storemap($coursenum,$coursedom,$folder.'.sequence');
            }
# Loading a complete map
	   if (($ENV{'form.importmap'}) && ($ENV{'form.loadmap'})) {
              foreach
(&Apache::lonsequence::attemptread(&Apache::lonnet::filelocation('',$ENV{'form.importmap'}))) {
                   my $idx=$#Apache::lonratedt::resources;
                   $idx++;
                   $Apache::lonratedt::resources[$idx]=$_;
                   $Apache::lonratedt::order
                            [$#Apache::lonratedt::order+1]=$idx;
                }

# Store the changed version
		&storemap($coursenum,$coursedom,$folder.'.sequence');
           }
       }
# ---------------------------------------------------------------- End commands
# ---------------------------------------------------------------- Print screen
        my $idx=0;
        $r->print('<table>');
        foreach (@Apache::lonratedt::order) {
           my ($name,$url)=split(/\:/,$Apache::lonratedt::resources[$_]);
           unless ($name) {  $name=(split(/\//,$url))[-1]; }
           unless ($name) { $name='NO RESOURCE'; $url='/adm/notfound.html'; }
           $r->print(&entryline($idx,$name,$url,$folder,$allowed,$_));
           $idx++;
        }
        $r->print('</table>');
    }
}

# --------------------------------------------------------------- An entry line

sub entryline {
    my ($index,$title,$url,$folder,$allowed,$residx)=@_;
    $title=~s/\&colon\;/\:/g;
    $title=&HTML::Entities::encode(&HTML::Entities::decode(
     &Apache::lonnet::unescape($title)),'\"\<\>\&\'');
    my $renametitle=$title;
    my $foldertitle=$title;
    if ($title=~
 /^(\d+)\_\_\_\&amp\;\&amp\;\&amp\;\_\_\_(\w+)\_\_\_\&amp\;\&amp\;\&amp\;\_\_\_(\w+)\_\_\_\&amp\;\&amp\;\&amp\;\_\_\_(.*)$/
	) { 
            $foldertitle=&Apache::lontexconvert::msgtexconverted($4);
            $renametitle=$4;
            $title='<i>'.localtime($1).'</i> '.
                &Apache::loncommon::plainname($2,$3).': <br>'.
		$foldertitle;
	}
    $renametitle=~s/\&quot\;/\\\"/g;
    my $line='<tr>';
# Edit commands
    if ($allowed) {
       $line.=(<<END);
<td><table border='0' cellspacing='2' cellpadding='0'>
<tr><td bgcolor="#DDDDDD">
<a href='/adm/coursedocs?folder=$folder&cmd=up_$index'>
<img src="${iconpath}move_up.gif" alt='UP' border='0' /></a></td></tr>
<tr><td bgcolor="#DDDDDD">
<a href='/adm/coursedocs?folder=$folder&cmd=down_$index'>
<img src="${iconpath}move_down.gif" alt='DOWN' border='0' /></a></td></tr>
</table></td><td bgcolor="#DDDDDD">
<a href='javascript:removeres("$folder","$index","$renametitle");'>
<font size="-2" color="#990000">Remove</font></a>
<a href='javascript:changename("$folder","$index","$renametitle");'>
<font size="-2" color="#009900">Rename</font></a></td>
END
    }
# Figure out what kind of a resource this is
    my ($extension)=($url=~/\.(\w+)$/);
    my $uploaded=($url=~/^\/*uploaded\//);
    my $icon='unknown';
    if (-e "/home/httpd/html/adm/lonIcons/$extension.gif") {
	$icon=$extension;
    }
    my $isfolder=0;
    if ($uploaded) {
       if ($extension eq 'sequence') {
	  $icon='folder_closed';
          $url=~/\/(\w+)\.sequence/;
          $url='/adm/coursedocs?folder='.$1;
          $isfolder=1;
       } else {
	  $url=&Apache::lonnet::tokenwrapper($url);
       } 
    }
    $url=~s/^http\&colon\;\/\//\/adm\/wrapper\/ext\//;
    if (($residx) && ($folder!~/supplemental/)) {
       $url.=(($url=~/\?/)?'&':'?').'symb='.
       &Apache::lonnet::escape(&Apache::lonnet::symbclean(
          &Apache::lonnet::declutter('uploaded/'.
           $ENV{'course.'.$ENV{'request.course.id'}.'.domain'}.'/'.
           $ENV{'course.'.$ENV{'request.course.id'}.'.num'}.'/'.$folder.
           '.sequence').
           '___'.$residx.'___'.
	   &Apache::lonnet::declutter($url)));
    }
    if ($isfolder) { $url.='&foldername='.
       &Apache::lonnet::escape($foldertitle); }
    $line.='<td bgcolor="#FFFFBB"><a href="'.$url.'" target="cat_'.$folder.
'"><img src="/adm/lonIcons/'.
        $icon.'.gif" border="0"></a></td>'.
        "<td bgcolor='#FFFFBB'><a href='$url' target='cat_$folder'>$title</a></td></tr>";
    return $line;
}

# ---------------------------------------------------------------- tie the hash

sub tiehash {
    $hashtied=0;
    if ($ENV{'request.course.fn'}) {
        if (tie(%hash,'GDBM_File',$ENV{'request.course.fn'}.".db",
            &GDBM_READER(),0640)) {
                $hashtied=1;
        }
    }    
}

sub untiehash {
    if ($hashtied) { untie %hash; }
    $hashtied=0;
}

# --------------------------------------------------------------- check on this

sub checkonthis {
    my ($r,$url,$level,$title)=@_;
    $alreadyseen{$url}=1;
    $r->rflush();
    if (($url) && ($url!~/^\/uploaded\//) && ($url!~/\*$/)) {
       $r->print('<br />');
       for (my $i=0;$i<=$level*5;$i++) {
           $r->print('&nbsp;');
       }
       $r->print('<a href="'.$url.'" target="cat">'.
		 ($title?$title:$url).'</a> ');
       if ($url=~/^\/res\//) {
	  my $result=&Apache::lonnet::repcopy(
                              &Apache::lonnet::filelocation('',$url));
          if ($result==OK) {
             $r->print('<font color="green">ok</font>');
             $r->rflush();
             &Apache::lonnet::countacc($url);
             $url=~/\.(\w+)$/;
             if (&Apache::loncommon::fileembstyle($1) eq 'ssi') {
		 $r->print('<br />');
                 $r->rflush();
                 for (my $i=0;$i<=$level*5;$i++) {
                     $r->print('&nbsp;');
                 }
                 $r->print('- Rendering: ');
                 my $oldpath=$ENV{'request.filename'};
                 $ENV{'request.filename'}=&Apache::lonnet::filelocation('',$url);
                 &Apache::lonxml::xmlparse($r,'web',
                   &Apache::lonnet::getfile(
                    &Apache::lonnet::filelocation('',$url)));
		 $ENV{'request.filename'}=$oldpath;
                 if (($Apache::lonxml::errorcount) ||
                     ($Apache::lonxml::warningcount)) {
		     if ($Apache::lonxml::errorcount) {
                        $r->print('<font color="red"><b>'.
			  $Apache::lonxml::errorcount.' error(s)</b></font> ');
                     }
		     if ($Apache::lonxml::warningcount) {
                        $r->print('<font color="blue">'.
			  $Apache::lonxml::warningcount.' warning(s)</font>');
                     }
                 } else {
                     $r->print('<font color="green">ok</font>');
                 }
                 $r->rflush();
             }
	     my $dependencies=
                &Apache::lonnet::metadata($url,'dependencies');
             foreach (split(/\,/,$dependencies)) {
		 if (($_=~/^\/res\//) && (!$alreadyseen{$_})) {
                    &checkonthis($r,$_,$level+1);
                 }
             }
          } elsif ($result==HTTP_SERVICE_UNAVAILABLE) {
             $r->print('<font color="red"><b>connection down</b></font>');
          } elsif ($result==HTTP_NOT_FOUND) {
             $r->print('<font color="red"><b>not found</b></font>');
          } else {
             $r->print('<font color="red"><b>access denied</b></font>');
          }
      }
   }
}

# ================================================================ Main Handler
sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

# --------------------------------------------- Initialize help topics for this
  foreach ('Adding_Course_Doc','Main_Course_Documents',
           'Adding_External_Resource','Navigate_Content',
           'Adding_Folders','Docs_Overview', 'Load_Map',
           'Supplemental', 'Score_Upload_Form',
           'Importing_LON-CAPA_Resource','Uploading_From_Harddrive') {
      $help{$_}=&Apache::loncommon::help_open_topic('Docs_'.$_);
  }
    # Composite help files
    $help{'Syllabus'} = &Apache::loncommon::help_open_topic(
		    'Docs_About_Syllabus,Docs_Editing_Templated_Pages');
    $help{'Simple Page'} = &Apache::loncommon::help_open_topic(
		    'Docs_About_Simple_Page,Docs_Editing_Templated_Pages');
    $help{'Bulletin Board'} = &Apache::loncommon::help_open_topic(
		    'Docs_About_Bulletin_Board,Docs_Editing_Templated_Pages');
    $help{'My Personal Info'} = &Apache::loncommon::help_open_topic(
		  'Docs_About_My_Personal_Info,Docs_Editing_Templated_Pages');
    $help{'Caching'} = &Apache::loncommon::help_open_topic('Caching');
 
  if ($ENV{'form.verify'}) {
 
   my $loaderror=&Apache::lonnet::overloaderror($r);
   if ($loaderror) { return $loaderror; }

   $r->print('<html><head><title>Verify Content</title></head>'.
              &Apache::loncommon::bodytag('Verify Course Documents'));
   $hashtied=0;
   undef %alreadyseen;
   %alreadyseen=();
   &tiehash();
   foreach (keys %hash) {
       if (($_=~/^src\_(.+)$/) && (!$alreadyseen{$hash{$_}})) {
           &checkonthis($r,$hash{$_},0,$hash{'title_'.$1});
       }
   }
   &untiehash();
   $r->print('<h1>Done.</h1>');
  } elsif ($ENV{'form.versions'}) {
    $r->print('<html><head><title>Check Versions</title></head>'.
              &Apache::loncommon::bodytag('Check Course Document Versions'));
   $hashtied=0;
   &tiehash();
   my %changes=&Apache::lonnet::dump
    ('versionupdate',$ENV{'course.'.$ENV{'request.course.id'}.'.domain'},
                     $ENV{'course.'.$ENV{'request.course.id'}.'.num'});
   my $firstkey=(keys %changes)[0];
   unless ($firstkey=~/^error\:/) {
       unless ($ENV{'form.timerange'}) {
	   $ENV{'form.timerange'}=604800;
       }
       my $seltext='during the last '.$ENV{'form.timerange'}.' seconds';
       my $startsel='';
       my $monthsel='';
       my $weeksel='';
       my $daysel='';
       if ($ENV{'form.timerange'}==-1) {
	   $seltext='since start of course';
           $startsel='selected';
           $ENV{'form.timerange'}=time;
       }
       my $starttime=time-$ENV{'form.timerange'};
       if ($ENV{'form.timerange'}==2592000) {
           $seltext='during the last month ('.localtime($starttime).')';
           $monthsel='selected';
       } elsif ($ENV{'form.timerange'}==604800) {
           $seltext='during the last week ('.localtime($starttime).')';
           $weeksel='selected';
       } elsif ($ENV{'form.timerange'}==86400) {
           $seltext='since yesterday ('.localtime($starttime).')';
           $daysel='selected';
       }
 
       $r->print(<<ENDHEADERS);
<form action="/adm/coursedocs" method="post">
<select name="timerange">
<option value="-1" $startsel>Since Start of Course</option>
<option value="2592000" $monthsel>Last Month</option>
<option value="604800" $weeksel>Last Week</option>
<option value="86400" $daysel>Since Yesterday</option>
</select>
<input type="submit" name="versions" value="Display" />
</form>
<h3>Content changed $seltext</h3>
<table border="2">
<tr>
<th>File</th><th>Modification Date</th>
<th>Version</th><th>Differences</th></tr>
ENDHEADERS
       foreach (keys %changes) {
	  if ($changes{$_}>$starttime) {
	     my ($root,$extension)=($_=~/^(.*)\.(\w+)$/);
             my $currentversion=&Apache::lonnet::getversion($_);
             my $linkurl=&Apache::lonnet::clutter($_);
             $r->print(
                 '<tr><td><a href="'.$linkurl.'" target="cat">'.$linkurl.
                 '</a></td><td>'.
                 localtime($changes{$_}).'</td><td>'.$currentversion.'</td>'.
		       '<td>');
             my $lastold=1;
             for (my $prevvers=1;$prevvers<$currentversion;$prevvers++) {
                 my $url=$root.'.'.$prevvers.'.'.$extension;
                 if (&Apache::lonnet::metadata($url,'lastrevisiondate')<
                                                             $starttime) {
                     $lastold=$prevvers;
                 }
             }
            for (my $prevvers=$lastold;$prevvers<$currentversion;$prevvers++) {
                 my $url=$root.'.'.$prevvers.'.'.$extension;
                 $r->print('<a href="'.&Apache::lonnet::clutter($url).
                   '">Version '.$prevvers.' ('.
                 localtime(&Apache::lonnet::metadata($url,'lastrevisiondate')).
                 ')</a>');
                 if (&Apache::loncommon::fileembstyle($extension) eq 'ssi') {
                    $r->print(' <a href="/adm/diff?filename='.
                            &Apache::lonnet::clutter($root.'.'.$extension).
                            '&versionone='.$prevvers.
			     '">Diffs</a>');
                 }
                 $r->print('<br />');
             }
             $r->print('</td></tr>');
          }
       }
       $r->print('</table>');
       $r->print('<h1>Done.</h1>');
   } else {
       $r->print('<p>No content modifications yet.</p>');
   }
   &untiehash();
  } else {
# is this a standard course?

    my $standard=($ENV{'request.course.uri'}=~/^\/uploaded\//);
    my $forcestandard;
    my $forcesupplement;
    my $script='';
    my $allowed;
    my $events='';
    my $buttons='';
    my $showdoc=0;
    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},
       ['folder','foldername']);
    if ($r->uri=~/^\/adm\/coursedocs\/showdoc\/(.*)$/) {
       $showdoc=$1;
    }
    unless ($showdoc) { # got called from remote
       $forcestandard=($ENV{'form.folder'}=~/^default_/);
       $forcesupplement=($ENV{'form.folder'}=~/^supplemental_/);

# does this user have privileges to post, etc?
       $allowed=&Apache::lonnet::allowed('srm',$ENV{'request.course.id'});
       if ($allowed) { 
         &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},['cmd']);
         $script=&Apache::lonratedt::editscript('simple'); 
       }
    } else { # got called in sequence from course
       $allowed=0;
       $script='</script>'.&Apache::lonmenu::registerurl(1,undef).'<script>';
       $events='onLoad="'.&Apache::lonmenu::loadevents.
           '" onUnload="'.&Apache::lonmenu::unloadevents.'"';
       $buttons=&Apache::lonmenu::menubuttons(1,undef);
    }

# get course data
    my $coursenum=$ENV{'course.'.$ENV{'request.course.id'}.'.num'};
    my $coursedom=$ENV{'course.'.$ENV{'request.course.id'}.'.domain'};

# get personal data
 
    my $uname=$ENV{'user.name'};
    my $udom=$ENV{'user.domain'};
    my $plainname=&Apache::lonnet::escape(
                     &Apache::loncommon::plainname($uname,$udom));

# graphics settings

    $iconpath = $r->dir_config('lonIconsURL') . "/";

    my $now=time;

# print screen
    $r->print(<<ENDDOCUMENT);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
<script>
$script
</script>
ENDDOCUMENT
   if ($allowed) {
    $r->print(<<ENDNEWSCRIPT);
<script>
function makenewfolder(targetform,folderseq) {
    var foldername=prompt('Name of New Folder','New Folder');
    if (foldername) {
	targetform.importdetail.value=foldername+"="+folderseq;
        targetform.submit();
    }
}

function makenewext(targetname) {
    this.document.forms.extimport.useform.value=targetname;
    window.open('/adm/rat/extpickframe.html');
}

function makeexamupload() {
   var title=prompt('Listed Title for the Uploaded Score');
   if (title) { 
    this.document.forms.newexamupload.importdetail.value=
	title+'=/res/lib/templates/examupload.problem';
    this.document.forms.newexamupload.submit();
   }
}

function makesmppage() {
   var title=prompt('Listed Title for the Page');
   if (title) { 
    this.document.forms.newsmppg.importdetail.value=
	title+'=/adm/$udom/$uname/$now/smppg';
    this.document.forms.newsmppg.submit();
   }
}

function makesmpproblem() {
   var title=prompt('Listed Title for the Problem');
   if (title) { 
    this.document.forms.newsmpproblem.importdetail.value=
	title+'=/res/lib/templates/simpleproblem.problem';
    this.document.forms.newsmpproblem.submit();
   }
}

function makebulboard() {
   var title=prompt('Listed Title for the Bulletin Board');
   if (title) {
    this.document.forms.newbul.importdetail.value=
	title+'=/adm/$udom/$uname/$now/bulletinboard';
    this.document.forms.newbul.submit();
   }
}

function finishpick() {
    var title=this.document.forms.extimport.title.value;
    var url=this.document.forms.extimport.url.value;
    var form=this.document.forms.extimport.useform.value;
    eval
     ('this.document.forms.'+form+'.importdetail.value="'+title+'='+url+
    '";this.document.forms.'+form+'.submit();');
}

function changename(folder,index,oldtitle) {
    var title=prompt('New Title',oldtitle);
    if (title) {
	this.document.forms.renameform.title.value=title;
	this.document.forms.renameform.cmd.value='rename_'+index;
	this.document.forms.renameform.folder.value=folder;
        this.document.forms.renameform.submit();
    }
}

function removeres(folder,index,oldtitle) {
    if ((oldtitle=='NO RESOURCE') || (confirm('Remove "'+oldtitle+'"?'))) {
	this.document.forms.renameform.cmd.value='del_'+index;
	this.document.forms.renameform.folder.value=folder;
        this.document.forms.renameform.submit();
    }
}
</script>

ENDNEWSCRIPT
  }
# -------------------------------------------------------------------- Body tag
  $r->print('</head>'.
            &Apache::loncommon::bodytag('Course Documents','',$events).
            $buttons);
  unless ($showdoc) {
    if ($allowed) {
       $r->print(&Apache::loncommon::help_open_topic('Docs_Adding_Course_Doc',
		     'Editing the Table of Contents for your Course'));
       $r->print(<<ENDCOURSEVERIFY);
<form name="renameform" method="post" action="/adm/coursedocs">
<input type="hidden" name="title" />
<input type="hidden" name="cmd" />
<input type="hidden" name="folder" />
</form>
<form name="simpleedit" method="post" action="/adm/coursedocs">
<input type=hidden name="importdetail" value="">
<input type="hidden" name="folder" />
</form>
<form action="/adm/coursedocs" method="post" name="courseverify">
<input type="submit" name="verify" value="Verify Content" />
<input type="submit" name="versions" value="Check Resource Versions" />
</form>
ENDCOURSEVERIFY
    }
# --------------------------------------------------------- Standard documents
    $r->print('<table border=2 cellspacing=4 cellpadding=4>');
    if (($standard) && ($allowed) && (!$forcesupplement)) {
       $r->print('<tr><td bgcolor="#BBBBBB"><h2>Main Course Documents'.
  ($allowed?' '.$help{'Main_Course_Documents'}:'').'</h2>');
       my $folder=$ENV{'form.folder'};
       unless ($folder=~/^default/) { $folder='default'; }
       my $postexec='';
       if ($folder eq 'default') {
	   $r->print('<script>this.window.name="loncapaclient";</script>');
       } else {
           $postexec='self.close();';
       }
       $hadchanges=0;
       &editor($r,$coursenum,$coursedom,$folder,$allowed);
       if ($hadchanges) {
	   $r->print(
'<script>function reinit(tf) { tf.submit();'.$postexec.' }</script>'. 
'<form method="post" action="/adm/roles" target="loncapaclient">'.
'<input type="hidden" name="orgurl" value="/adm/coursedocs" /><input type="hidden" name="selectrole" value="1" /><h3><font color="red">Changes will become active for your current session after <input type="hidden" name="'.
$ENV{'request.role'}.'" value="1" /><input type="button" value="re-initializing course" onClick="reinit(this.form)"/>, or the next time you log in.'.
$help{'Caching'}.'</font></h3></form>');
       }
       my $folderseq='/uploaded/'.$coursedom.'/'.$coursenum.'/default_'.time.
                     '.sequence';

       $r->print(<<ENDFORM);
<table cellspacing=4 cellpadding=4><tr>
<th bgcolor="#DDDDDD">Upload a new main course document</th>
<th bgcolor="#DDDDDD">Import a published document</th>
<th bgcolor="#DDDDDD">Special documents</th>
</tr>
<tr><td bgcolor="#DDDDDD">
File:<br />
<form action="/adm/coursedocs" method="post" enctype="multipart/form-data">
<input type="file" name="uploaddoc" size="40">
<br />
Title:<br />
<input type="text" size="50" name="comment">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type="hidden" name="cmd" value="upload_default">
<input type="submit" value="Upload Document">
<nobr>
 $help{'Uploading_From_Harddrive'}
</nobr>
</form>
</td>
<td bgcolor="#DDDDDD">
<form action="/adm/coursedocs" method="post" name="simpleeditdefault">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=button onClick=
"javascript:document.forms.simpleedit.folder.value='$folder';groupsearch()" value="Search">
<nobr>
<input type=button onClick=
"javascript:document.forms.simpleedit.folder.value='$folder';groupimport();" value="Import">
$help{'Importing_LON-CAPA_Resource'}
</nobr>
<p>
<hr />
<input type="text" size="20" name="importmap"><br />
<nobr><input type=button 
onClick="javascript:openbrowser('simpleeditdefault','importmap','sequence,page','')"
value="Select Map"> <input type="submit" name="loadmap" value="Load Map">
$help{'Load_Map'}</nobr>
</p>
</form>
</td><td bgcolor="#DDDDDD">
<form action="/adm/coursedocs" method="post" name="newfolder">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newfolder" type="button"
onClick="javascript:makenewfolder(this.form,'$folderseq');"
value="New Folder" />$help{'Adding_Folders'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newext">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newext" type="button" onClick="javascript:makenewext('newext');"
value="External Resource" /> $help{'Adding_External_Resource'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newsyl">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" 
value="Syllabus=/public/$coursedom/$coursenum/syllabus">
<nobr>
<input name="newsyl" type="submit" value="Syllabus" /> 
 $help{'Syllabus'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newnav">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" 
value="Navigate Content=/adm/navmaps">
<nobr>
<input name="newnav" type="submit" value="Navigate Content" />
$help{'Navigate_Content'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newsmppg">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newsmppg" type="button" value="Simple Page"
onClick="javascript:makesmppage();" /> $help{'Simple Page'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newexamupload">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newexamupload" type="button" value="Score Upload Form"
onClick="javascript:makeexamupload();" />
$help{'Score_Upload_Form'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newbul">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newbulletin" type="button" value="Bulletin Board"
onClick="javascript:makebulboard();" />
$help{'Bulletin Board'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="newaboutme">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" 
value="$plainname=/adm/$udom/$uname/aboutme">
<nobr>
<input name="newaboutme" type="submit" value="My Personal Info" />
$help{'My Personal Info'}
</nobr>
</form>
</td></tr>
</table>
ENDFORM
       $r->print('</td></tr>');
    }
# ----------------------------------------------------- Supplemental documents
    if (!$forcestandard) {
       $r->print(
  '<tr><td bgcolor="#BBBBBB"><h2>Supplemental Course Documents'.
  ($allowed?' '.$help{'Supplemental'}:'').'</h2>');
       my $folder=$ENV{'form.folder'};
       unless ($folder=~/supplemental/) { $folder='supplemental'; }
       &editor($r,$coursenum,$coursedom,$folder,$allowed);
       if ($allowed) {
       my $folderseq=
                  '/uploaded/'.$coursedom.'/'.$coursenum.'/supplemental_'.time.
                     '.sequence';

          $r->print(<<ENDSUPFORM);
<table cellspacing=4 cellpadding=4><tr>
<th bgcolor="#DDDDDD">Upload a new supplemental course document</th>
<th bgcolor="#DDDDDD">Import a published document</th>
<th bgcolor="#DDDDDD">Special documents</th>
</tr>
<tr><td bgcolor="#DDDDDD">
<form action="/adm/coursedocs" method="post" enctype="multipart/form-data">
<input type="file" name="uploaddoc" size="40">
<br />Comment:<br />
<textarea cols=50 rows=4 name='comment'>
</textarea>
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type="hidden" name="cmd" value="upload_supplemental">
<nobr>
<input type="submit" value="Upload Document">
 $help{'Uploading_From_Harddrive'}
</nobr>
</form>
</td>
<td bgcolor="#DDDDDD">
<form action="/adm/coursedocs" method="post" name="simpleeditsupplement">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<input type=button onClick=
"javascript:document.forms.simpleedit.folder.value='$folder';groupsearch()" value="Search">
<input type=button onClick=
"javascript:document.forms.simpleedit.folder.value='$folder';groupimport();" value="Import">$help{'Importing_LON-CAPA_Resource'}
<p>
<hr />
<input type="text" size="20" name="importmap">
<input type=button 
onClick="javascript:openbrowser('simpleeditsupplement','importmap','sequence,page','')"
value="Select Map"><input type="submit" name="loadmap" value="Load Map">
</p>
</form>
</td><td bgcolor="#DDDDDD">
<form action="/adm/coursedocs" method="post" name="supnewfolder">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newfolder" type="button"
onClick="javascript:makenewfolder(this.form,'$folderseq');"
value="New Folder" /> $help{'Adding_Folders'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="supnewext">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" value="">
<nobr>
<input name="newext" type="button" 
onClick="javascript:makenewext('supnewext');"
value="External Resource" /> $help{'Adding_External_Resource'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="supnewsyl">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" 
value="Syllabus=/public/$coursedom/$coursenum/syllabus">
<nobr>
<input name="newsyl" type="submit" value="Syllabus" />
$help{'Syllabus'}
</nobr>
</form>
<form action="/adm/coursedocs" method="post" name="subnewaboutme">
<input type="hidden" name="folder" value="$folder">
<input type="hidden" name="foldername" value="$ENV{'form.foldername'}">
<input type=hidden name="importdetail" 
value="$plainname=/adm/$udom/$uname/aboutme">
<nobr>
<input name="newaboutme" type="submit" value="My Personal Info" />
$help{'My Personal Info'}
</nobr>
</form>
</td></tr>
</table></td></tr>
ENDSUPFORM
       }
    }
    if ($allowed) {
	$r->print('<form name="extimport"><input type="hidden" name="title"><input type="hidden" name="url"><input type="hidden" name="useform"></form>');
    }
    $r->print('</table>');
  } else {
# -------------------------------------------------------- This is showdoc mode
      $r->print("<h1>Uploaded Document</h1><p>It is recommended that you use an up-to-date virus scanner before handling this file.</p><p><table>".
         &entryline(0,"Click to download or use your browser's Save Link function",$showdoc).'</table></p>');
  }
 }
 $r->print('</body></html>');
 return OK;
} 

1;
__END__
