# The LearningOnline Network
# Pick a course
#
# $Id: lonpickcourse.pm,v 1.7 2003/03/28 01:53:55 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::lonpickcourse;

use strict;
use Apache::Constants qw(:common);
use Apache::loncommon;
use Apache::loncoursedata;
use Apache::lonnet;

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

# ------------------------------------------------------------ Print the screen
    $r->print(<<ENDDOCUMENT);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
ENDDOCUMENT
# Get parameters from query string
    &Apache::loncommon::get_unprocessed_cgi
        ($ENV{'QUERY_STRING'},['domainfilter','descriptfilter',
                 'sincefilter','form','cnumelement','cdomelement']);
# domain filter and selection
    my $domainfilter=$ENV{'form.domainfilter'};
    $domainfilter=~s/\W//g;
    unless ($domainfilter) { $domainfilter=''; }
    my $domainselectform=&Apache::loncommon::select_dom_form($domainfilter,
                                                          'domainfilter',1);
# description filter
    my $descriptfilter=$ENV{'form.descriptfilter'};
    $descriptfilter=~s/[^\w\s]//g;
    unless ($descriptfilter) { $descriptfilter=''; }

# last course activity filter and selection
    my $sincefilter=$ENV{'form.sincefilter'};
    $sincefilter=~s/[^\d-]//g;
    unless ($sincefilter) { $sincefilter=-1; }
    my $sincefilterform=&Apache::loncommon::select_form($sincefilter,
       'sincefilter',('-1'=>'',
                      '86400' => 'today',
                      '604800' => 'last week',
                      '2592000' => 'last month',
                      '7776000' => 'last three months',
                      '15552000' => 'last six months',
                      '31104000' => 'last year'));
       
    $r->print(&Apache::loncommon::bodytag("Selecting a Course"));
    $r->print(<<ENDSCRIPT);
<script>
function gochoose(cname,cdom) {
    opener.document.$ENV{'form.form'}.$ENV{'form.cnumelement'}.value=cname;
    var slct=opener.document.$ENV{'form.form'}.$ENV{'form.cdomelement'};
    var i;
    for (i=0;i<slct.length;i++) {
        if (slct.options[i].value==cdom) { slct.selectedIndex=i; }
    }
    self.close();
}
</script>
<form method="post">
<input type="hidden" name="cnumelement" value="$ENV{'form.cnumelement'}" />
<input type="hidden" name="cdomelement" value="$ENV{'form.cdomelement'}" />
<input type="hidden" name="form" value="$ENV{'form.form'}" />

Course Activity: $sincefilterform
<br />
Course Domain: $domainselectform
<br />
Course Description:
<input type="text" name="descriptfilter" size="40" value="$descriptfilter" />
<p><input type="submit" name="gosearch" value="Search" /></p>
</form>
<hr />
ENDSCRIPT
# ---------------------------------------------------------------- Get the data
    if ($ENV{'form.gosearch'}) {
        $r->print('Searching ...<br />&nbsp;<br />');
        $r->rflush();
	unless ($descriptfilter) { $descriptfilter='.'; }
        my $timefilter=($sincefilter==-1?1:time-$sincefilter);
	my %courses=
	    &Apache::lonnet::courseiddump
	    ($domainfilter,$descriptfilter,$timefilter);
	$r->print('<form>');
	foreach (keys %courses) {
	    my ($cdom,$cnum)=split(/\_/,$_);
	    $r->print('<input type="button" value="Select" onClick="gochoose('.
		  "'".$cnum."','".$cdom."')".'" /> '.$courses{$_}.' ('.
		  ($Apache::lonnet::domaindescription{$cdom}?
                   $Apache::lonnet::domaindescription{$cdom}:$cdom).
                 ")<br />\n");
	}
        $r->print('</form>');
    }
    $r->print('</body></html>');
    return OK;
} 

1;
__END__
