# The LearningOnline Network
# URL translation for User Files
#
# $Id: lontrans.pm,v 1.5 2003/03/26 00:03:21 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::lontrans;

use strict;
use Apache::Constants qw(:common :remotehost);
use Apache::lonnet();
use Apache::File();

sub propath {
    my ($udom,$uname)=@_;
    $udom=~s/\W//g;
    $uname=~s/\W//g;
    my $subdir=$uname.'__';
    $subdir =~ s/(.)(.)(.).*/$1\/$2\/$3/;
    my $proname="$Apache::lonnet::perlvar{'lonUsersDir'}/$udom/$subdir/$uname";
    return $proname;
}


sub handler {
    my $r = shift;
    if ($r->uri=~m|^/uploaded/|) {
	my (undef,undef,$udom,$uname,$ufile)=split(/\//,$r->uri);
	$ufile=~s/^[\~\.]+//;
	$r->filename(&propath($udom,$uname).'/userfiles/'.$ufile);
    } elsif ($r->uri=~m|^/~|) {	
	#internal authentication, needs fixup.
	my $fn = $r->uri(); # non users do not get the full path request
	                 # through SCRIPT_FILENAME
	$fn=~s|^/~(\w+)|/home/$1/public_html|;
	$r->filename($fn);
    } else { return DECLINED; }
    return OK;
}

1;
__END__







