#!/usr/bin/perl
# The LearningOnline Network
#
# $Id: cleanup_prtspool.pl,v 1.2 2002/11/21 19:41:54 matthew Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
#################################################

=pod

=head1 NAME

cleanup_prtspool.pl - Remove temporary files from the LON-CAPA print spool.

=head1 SYNOPSIS

cleanup_prtspool.pl deletes files from /home/httpd/prtspool that have not
been accessed in 24 hours.

=head1 DESCRIPTION

cleanup_prtspool.pl examines each file in /home/httpd/prtspool and checks
its last access time.  Those files which have not been accessed in 24 hours
are unlinked.

=cut

#################################################

use strict;
use lib '/home/httpd/lib/perl/';
use File::Find;
use File::stat;

my $help = 0;
my $killtime = time - 24 * 60 * 60;

sub kill_if_old {
    my $filename = $File::Find::name;
    return if (! -f $filename); # We only want files
    my $inode =stat($filename);
    if ($inode->atime < $killtime) {
        unlink($filename);
    }
}

find (\&kill_if_old,'/home/httpd/prtspool');
