# The LearningOnline Network with CAPA
# Construction Space Page Wrapper for Construction
#
# $Id: lonconstruct.pm,v 1.13 2003/06/16 21:32:43 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
#
# (Page Handler
#
# (TeX Content Handler
#
# 05/29/00,05/30 Gerd Kortemeyer)
# 08/30,08/31,09/06,09/14,09/15,09/16,09/19,09/20,09/21,09/23,
# 10/02,10/10,10/14,10/16,10/18,10/19,10/31,11/6,11/14,11/16 Gerd Kortemeyer)
#
# 11/22,11/23,11/28,
# 03/30/01 Gerd Kortemeyer
package Apache::lonconstruct;


use strict;
use Apache::Constants qw(:common :http :methods);
use Apache::lonnet;
use Apache::Log ();
use HTML::Entities();

my $DEBUG = 0;
=pod

=item Debug($request, $message)

  If debugging is enabled puts out a debuggin message determined by the
  caller.  The debug message goes to the Apache error log file. Debugging
  is enabled by ssetting the module global DEBUG variable to nonzero (TRUE).

 Parameters:

=over 4
 
=item $request - The curretn request operation.

=item $message - The message to put inthe log file.

=back
  
 Returns:
   nothing.

=cut

sub Debug {
  
  # Marshall the parameters.
  
  my $r       = shift;
  my $log     = $r->log;
  my $message = shift;
  
  # Put out the indicated message butonly if DEBUG is false.
  
  if ($DEBUG) {
    $log->debug($message);
  }
}




# ================================================================ Main Handler

sub handler {
   my $r=shift;

# -------------------------------------------------------------- Build frameset

   $r->content_type('text/html');
   $r->send_http_header;
   return OK if $r->header_only;

   my $lowerframe=$r->path_info;

   &Debug($r, "Initial URL for lower frame: ".$lowerframe);
   $lowerframe=~s/^\//\/\~/;
   &Debug($r, "Lower frame URL afer ~ subst: ".$lowerframe);
   $lowerframe= &HTML::Entities::encode($lowerframe);
   &Debug($r, "LOwer frame URL after quote subst: ".$lowerframe);

#
# Are we forcing edit mode?
#

   &Apache::loncommon::get_unprocessed_cgi
        ($ENV{'QUERY_STRING'},['forceedit']);
   if ($ENV{'form.forceedit'}) {
       $lowerframe.='?editmode=Edit&problemmode=EditXML';
   }

   $r->print(<<ENDPAGE);
<html>
<head><title>LON-CAPA Construction Space</title>
<script language="JavaScript">
var lastknownpriv="$lowerframe";
</script>
</head>
<frameset rows="110,*" border="0">
<frame src='/adm/publisher.html'>
<frame src="$lowerframe" name="LONCAPAToBePublished">
</frameset>
</html>
ENDPAGE
   return OK;
}
1;
__END__

