# The LearningOnline Network
# Unauthorized to access construction space
#
# $Id: lonunauthorized.pm,v 1.1 2002/09/10 14:41:05 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

package Apache::lonunauthorized;

use strict;
use Apache::Constants qw(:common);
use Apache::loncommon;
use Apache::lonnet;
use Apache::loncacc;

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

# ------------------------------------------------------------ Print the screen
    $r->print(<<ENDDOCUMENT);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
</head>
ENDDOCUMENT
# Figure out who the user is and what they wanted to access

    my ($ownername,$ownerdomain)=
     &Apache::loncacc::constructaccess($ENV{'request.editurl'},$r->dir_config('lonDefDomain'));
# print header
    $r->print(&Apache::loncommon::bodytag
           ("Failed Access to Construction Space",'','','',$ownerdomain));
# figure out what went wrong

    if ($ownerdomain) {
	$r->print('<h1>Choose another server</h1>'.
 "<p>The constuction space for this resource is located on another server.</p>"
        );
        my $ownerhome=&Apache::lonnet::homeserver($ownername,$ownerdomain);
        unless ($ownerhome eq 'no_host') {
	    $r->print(
 "<p>Please log into <tt>".$Apache::lonnet::hostname{$ownerhome}.
 "</tt> to edit.</p>");
        }
    } else {
        $r->print(
            "<h1>You do not have authoring privileges for this resource</h1>");
        my ($realownername)=($ENV{'request.editurl'}=~/\/(?:\~|priv\/|home\/)(\w+)/);
        my $realownerhome=
      &Apache::lonnet::homeserver(
        $realownername,$r->dir_config('lonDefDomain'));
        unless ($realownerhome eq 'no_host') {
           $r->print("<p>Contact ".
    &Apache::loncommon::aboutmewrapper(
     &Apache::loncommon::plainname($realownername,
                               $r->dir_config('lonDefDomain')).'('.
                               $realownername.' at '.
                               $r->dir_config('lonDefDomain').')',
			       $realownername,$r->dir_config('lonDefDomain')).
           ' for access.');
        }
    }
    
    $r->print('</body></html>');
    return OK;
} 

1;
__END__
