# The LearningOnline Network with CAPA
# TeX Content Handler
#
# $Id: lontex.pm,v 1.5 2003/02/17 17:34:17 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
#
# Copyright for TtHfunc and TtMfunc by Ian Hutchinson. 
# TtHfunc and TtMfunc (the "Code") may be compiled and linked into 
# binary executable programs or libraries distributed by the 
# Michigan State University (the "Licensee"), but any binaries so 
# distributed are hereby licensed only for use in the context
# of a program or computational system for which the Licensee is the 
# primary author or distributor, and which performs substantial 
# additional tasks beyond the translation of (La)TeX into HTML.
# The C source of the Code may not be distributed by the Licensee
# to any other parties under any circumstances.
#
# 05/29/00,05/30,10/11 Gerd Kortemeyer

package Apache::lontex;

use strict;
use Apache::File;
use Apache::lontexconvert;
use Apache::Constants qw(:common);
use tth;

# ================================================================ Main Handler

sub handler {
  my $r=shift;
  my @texcontents;
  my $texstring;

# ----------------------------------------------------------- Set document type

  if ($ENV{'browser.mathml'}) {
    $r->content_type('text/xml');
  } else {
    $r->content_type('text/html');
  }
  $r->send_http_header;

  return OK if $r->header_only;

# ------------------------------------------------------------------- Read file

  {
    my $fh=Apache::File->new($r->filename);
    @texcontents=<$fh>;
  }

  $texstring=join("\n",@texcontents);

# --------------------------------------------------------------- Render Output
  
  $r->print(&Apache::lontexconvert::header());
  $r->print(
    '<body bgcolor="#FFFFFF" onLoad="'.
      &Apache::lonmenu::loadevents().
    '" onUnload="'.
      &Apache::lonmenu::unloadevents().
    '">'.
      &Apache::lonmenu::menubuttons(undef,'web',1)
  );
  $r->print(&Apache::lontexconvert::converted(\$texstring));
  $r->print('</body>');
  $r->print(&Apache::lontexconvert::footer());

  return OK;
}

1;
__END__







