package Apache::run;
#
# $Id: run.pm,v 1.39 2003/06/18 21:04:42 albertel Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#

use HTML::Entities;

$Apache::run::EVALUATE_STRING=<<'ENDEVALUATE';  
  my %_LONCAPA_INTERNAL_oldexpressions=();
  while (!$_LONCAPA_INTERNAL_oldexpressions{$_}) {
    $_LONCAPA_INTERNAL_oldexpressions{$_}=1;
    $_ =~s/((?:\$|\&)(?:[\#|\$]*[A-Za-z][\w]*|\{[A-Za-z][\w]*\}))([\[\{][^\$\&\]\}]+[\]\}])*?(\([^\$\&\)]+\))*?(?=[^\[\{\(]|$)/eval(defined(eval($1.$2))?eval('$1.$2.$3'):'$1.$2.$3')/seg;
    if (scalar(values(%_LONCAPA_INTERNAL_oldexpressions))>10) {last;}
  }
ENDEVALUATE

sub evaluate {
    my ($expression,$safeeval,$decls) = @_;
    unless (defined($expression)) { return ''; }
    if ($Apache::lonxml::evaluate < 1) { return $expression; }
    my $result = '';
    $@='';
    $Apache::run::timeout=0;
    $main::SIG{'ALRM'} = sub {
	$Apache::run::timeout=1;
	die("timeout");
    };
    my $innererror;
    eval {
	alarm($Apache::lonnet::perlvar{'lonScriptTimeout'});
	$safeeval->reval('{'.$decls.';$_=<<\'EXPRESSION\';'."\n".$expression.
			 "\n".'EXPRESSION'."\n".$EVALUATE_STRING.'}');
	$innererror=$@;
	alarm(0);
    };
    my $error=$@;
    if ($error eq '' && $innererror eq '' && !$Apache::run::timeout) {
	$result = $safeeval->reval('return $_;');
	chomp $result;
    } else {
	if ($Apache::run::timeout) {
	    $error = 'Code ran too long. It ran for more than '.
		Apache->request->server->timeout.' seconds';
	}
	&Apache::lonxml::error('substitution on <pre>'.
			       &HTML::Entities::encode($expression).
			       '</pre> with <pre>'.
			       &HTML::Entities::encode($decls).
			       '</pre> caused <pre>'.
			       &HTML::Entities::encode($error).' '.
			       &HTML::Entities::encode($innererror).
			       '</pre>');
    }
    return $result
}

sub run {
    my ($code,$safeeval,$hideerrors) = @_;
    my @result;
    $@='';
    $Apache::run::timeout=0;
    $main::SIG{'ALRM'} = sub {
	$Apache::run::timeout=1;
	die("timeout");
    };
    my $innererror;
    eval {
	alarm($Apache::lonnet::perlvar{'lonScriptTimeout'});
	@result=$safeeval->reval($code);
	$innererror=$@;
	alarm(0);
    };
    my $error=$@;
    if (($Apache::run::timeout || $error ne '' || $innererror ne '') && !$hideerrors) {
	if ($Apache::run::timeout) {
	    $error = 'Code ran too long. It ran for more than '.
		Apache->request->server->timeout.' seconds';
	}
	&Apache::lonxml::error('<pre>'.&HTML::Entities::encode($error).' '.
			       &HTML::Entities::encode($innererror).
			       '</pre> occured while running <pre>'.
			       &HTML::Entities::encode($code).'</pre>');
    }
    if ( $#result < '1') {
	return $result[0];
    } else {
	&Apache::lonxml::debug("<b>Got lots results</b>:$#result:");
	return (@result);
    }
}

sub dump {
  my ($target,$safeeval)=@_;
  my $dump='';
  foreach my $symname (sort keys %{$safeeval->varglob('main::')}) {
    if (($symname!~/^\_/) && ($symname!~/\:$/)) {
      my $line;
      if ($safeeval->reval('defined($'.$symname.')')) {
	$line='$'.$symname.'='.$safeeval->reval('$'.$symname);
      }	
      if ($safeeval->reval('defined(@'.$symname.')')) {
	$line='@'.$symname.'=('.
	  $safeeval->reval('join(",",@'.$symname.')').")";
      }
      if ($safeeval->reval('defined(%'.$symname.')')) {
	$line='%'.$symname.'=(';
	$line.=$safeeval->reval('join(",",map { $_."=>".$'.
				$symname.'{$_} } sort keys %'.
				$symname.')').")"
      }
      if ($line ne '') { $dump.=&HTML::Entities::encode($line)."<br />"; }
    }
  }
  $dump.='';
  return $dump;
}

1;
__END__;
