# The LearningOnline Network with CAPA
# Set parameters inside of the RAT
#
# $Id: lonratparms.pm,v 1.15 2003/04/30 16:08:30 matthew Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Search Catalog
#
# (Internal Server Error Handler
#
# (Login Screen
# 5/21/99,5/22,5/25,5/26,5/31,6/2,6/10,7/12,7/14,
# 1/14/00,5/29,5/30,6/1,6/29,7/1,11/9 Gerd Kortemeyer)
#
# 3/1/1 Gerd Kortemeyer)
#
# 3/1 Gerd Kortemeyer)
#
# 03/03/01,06/15,06/25,06/26,06/30,07/02,07/03,07/04 Gerd Kortemeyer
# 03/11/02 Matthew Hall
#
package Apache::lonratparms;

use strict;
use Apache::Constants qw(:common);
use Apache::lonhtmlcommon();

sub handler {
    my $r = shift;
    $r->content_type('text/html');
    $r->send_http_header;
    return OK if $r->header_only;

# Get query string for limited number of parameters

    &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},
                                            ['url','parms','resid']);

# ------------------------------------------------------------------- Read file

  my $uri=$ENV{'form.url'}.'.meta';
  
  my %content;
  my %type;
  my %display;
  my %value;
  
  foreach (split(/\,/,&Apache::lonnet::metadata($uri,'keys'))) {
      if ($_=~/^parameter\_/) {
         $content{$_}=&Apache::lonnet::metadata($uri,$_);
         $type{$_}=&Apache::lonnet::metadata($uri,$_.'.type');
         $display{$_}=&Apache::lonnet::metadata($uri,$_.'.display');
      }
  }

# -------------------------------------- Additional parms for certain resources

    if ($uri=~/\.(sequence|page)\.meta$/) {
        $content{'parameter_randompick'}='';
        $type{'parameter_randompick'}='int_pos';
	$display{'parameter_randompick'}='Randomly pick number of resources';
        
        $content{'parameter_randompickseed'}='';
        $type{'parameter_randompickseed'}='int_pos';
	$display{'parameter_randompickseed'}=
 'Random seed for randomly picking number of resources (optional, only set if you know what you are doing)';
    } else {
        $content{'parameter_mapalias'}='';
        $type{'parameter_mapalias'}='string';
	$display{'parameter_mapalias'}='Resource alias name for conditions';
    }
    if ($uri=~/\.(problem|exam|quiz|assess|survey|form|library)\.meta$/) {
	$content{'parameter_hiddenparts'}='';
        $type{'parameter_hiddenparts'}='string';
	$display{'parameter_hiddenparts'}=
	    'A comma separted list of Part Ids to not display.';
    }
# ---------------------------------------------------------- Current Parameters

  foreach (split(/\:/,$ENV{'form.parms'})) {
      my ($ptype,$pname,$pvalue)=split(/\_\_\_/,$_);
      unless ($type{$pname}) { $type{$pname}=$ptype; }
      $value{$pname}=$pvalue;
  } 
  
# --------------------------------------------------- Print input screen header
    my $pjump_def = &Apache::lonhtmlcommon::pjump_javascript_definition();
    $r->print(<<ENDHEADER);
<html>
<head>
<title>The LearningOnline Network with CAPA</title>
<script language="JavaScript">

    function pclose() {
        parmwin=window.open("/adm/rat/empty.html","LONCAPAparms",
                 "height=350,width=350,scrollbars=no,menubar=no");
        parmwin.close();
    }

    $pjump_def

    function stpr() {
        eval("document.parameters."+document.parameters.pres_marker.value+
            ".value=document.parameters.pres_value.value");
        pclose();
    }


function setparms() {
ENDHEADER
    $r->print('var colon=""; opener.objparms['.$ENV{'form.resid'}.']="";');
    map {
       $r->print("\nif (document.parameters.def_".$_.
       '.checked) { opener.objparms['.$ENV{'form.resid'}.
       ']+=colon+"'.$type{$_}.
       '___'.$_.'___"+document.parameters.'.$_.'.value; colon=":"; }'); 
    } keys %content;
    $r->print(<<ENDDOCUMENT);
    opener.save();
    window.close();
}
</script>
</head>
<body bgcolor="#FFFFFF">
<h1>Set Resource Parameters in Map</h1>
<form action="javascript:setparms();" method="post" name="parameters">
<input type="hidden" value='' name="pres_value">
<input type="hidden" value='' name="pres_type">
<input type="hidden" value='' name="pres_marker">
<table border=2>
<tr><th>Parameter</th><th>Default</th><th>Value</th><th>Set?</th></tr>
ENDDOCUMENT
    foreach (keys(%content)) {
        my $cur=$content{$_};
        # Should if(defined($value{$_})) be if(exists($value{$_})) ?
        if (defined($value{$_})) { $cur=$value{$_}; };
        $r->print(<<"END");
<tr><td><b>$display{$_}</b><br><tt>$_</tt></td>
<td>&nbsp;$content{$_}</td>
<td><input type="text" size="10" name="$_" value="$cur">&nbsp;
<a href='javascript:pjump("$type{$_}","$display{$_}",document.parameters.$_.value,"$_","parameters.pres","stpr");'>Enter</a></td>
<td><input type="checkbox" name="def_$_" 
END
        if ($value{$_}) { $r->print(' checked'); }
        $r->print('></td></tr>');
    }
    $r->print(
        '</table><br><input type="submit" value="Set"></form></body></html>');
    return OK;
} 

1;
__END__

