# The LearningOnline Network with CAPA
# Wrapper for external and binary files as standalone resources
#
# $Id: lonwrapper.pm,v 1.13 2003/05/13 15:13:17 www Exp $
#
# Copyright Michigan State University Board of Trustees
#
# This file is part of the LearningOnline Network with CAPA (LON-CAPA).
#
# LON-CAPA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# LON-CAPA is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with LON-CAPA; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# /home/httpd/html/adm/gpl.txt
#
# http://www.lon-capa.org/
#
# (Edit Handler for RAT Maps
# (TeX Content Handler
#
# 05/29/00,05/30 Gerd Kortemeyer)
# 7/1,6/30 Gerd Kortemeyer)
#
# 7/5 Gerd Kortemeyer

package Apache::lonwrapper;

use strict;
use Apache::Constants qw(:common);
use Apache::lonnet();
use Apache::lonxml();
use Apache::lonmenu;

# ================================================================ Main Handler

sub handler {
  my $r=shift;
  $r->content_type('text/html');
  $r->send_http_header;

  return OK if $r->header_only;

  &Apache::loncommon::get_unprocessed_cgi($ENV{'QUERY_STRING'},
                                          ['wrapperdisplay']);
  my $orgurl=$r->uri;
  my $url=$orgurl;
  $url=~s/^\/adm\/wrapper//;
  $url=~s/^\/ext\//http\:\/\//;
  if ($ENV{'form.wrapperdisplay'} eq 'menu') {
#
# Producing the menu buttons
#
      $r->print('<html><body bgcolor="#FFFFFF">'.
                &Apache::lonmenu::menubuttons(1,'web',1).'</body></html>');
  } else {
#
# Actual URL
#
      if ($url=~/\.(problem|exam|quiz|assess|survey|form|library)$/) {
#
# This is uploaded homework
#
          $ENV{'request.state'}='uploaded';
          &Apache::lonhomework::renderpage($r,$url);
      } else {
#
# This is not homework
#
	  if ($url=~/^\/uploaded\//) {
	      $url=&Apache::lonnet::tokenwrapper($url);
	  }
	  $url.=(($url=~/\?/)?'&':'?').$ENV{'QUERY_STRING'}; 
                                                 # reappend the query arguments
	  my $events='onLoad="'.&Apache::lonmenu::loadevents.
	      '" onUnload="'.&Apache::lonmenu::unloadevents.'"';
	  my $script=&Apache::lonmenu::registerurl(1,undef);

	  if ($ENV{'browser.interface'} eq 'textual') {
#
# ssi-based rendering for text-based interface
#
	      $r->print('<html><head>'.
			&Apache::lonmenu::registerurl(1).
			'</head><body bgcolor="#FFFFFF">'.
			&Apache::lonmenu::menubuttons(1).
			&Apache::lonnet::ssi_body($url).'</body></html>');
	  } elsif ($ENV{'environment.remote'} eq 'off') {
#
# This is inline remote
# 
	      $r->print(<<ENDDOCUMENTINL);
<html>
<head>
$script
</head>
<frameset rows="180,*" border=0 $events>
<frame src="$orgurl?wrapperdisplay=menu">
<frame src="$url">
</frameset>
</html>
ENDDOCUMENTINL
          } else {
#
# frame-based rendering for graphical interface
#
	  $r->print(<<ENDDOCUMENT);
<html>
<head>
$script
</head>
<frameset rows="1,*" border=0 $events>
<frame src="/adm/rat/empty.html">
<frame src="$url">
</frameset>
</html>
ENDDOCUMENT
          }
      } # not homework
  } # not just the menu
  return OK;
} # handler

1;
__END__







